Subject: Re: bug#16028: 24.3.50; Latest build completely breaks my thumnail frames code

From: Eli Zaretskii <[email-masked]>
Date: Sat, 07 Dec 2013 13:15:16 +0200

> Date: Sat, 07 Dec 2013 10:46:44 +0100
> From: martin rudalics <[email-masked]>
> CC: [email-masked], [email-masked]
> 
>  >> x_set_font does a lot to make redisplay happen.
>  >
>  > You mean the call to clear_current_matrices?  AFAIR, that's not
>  > enough: it just ensures that _when_ redisplay happens, every screen
>  > line will get redrawn.  But it doesn't force redisplay.
>  >
>  > Perhaps try calling fset_redisplay for that frame.
> 
> If there are no errors, x_set_font inevitably calls x_new_font which on
> window inevitably calls x_set_window_size which inevitably calls
> my_set_window_pos.

But my_set_window_pos just tells Windows to redraw the frame according
to the current dimensions.  It's the current dimensions that need to
be changed, and that is done by redisplay, when it notices that the
font was changed and therefore the dimensions of the glyph matrices
need to be updated.

> BTW I could hardly analyze this at the moment because now I'm bitten by
> the "modeline doesn't update correctly" virus.  `find-tag-noselect',
> when trying to go to the definition of x_new_font, switches from
> nsterm.m to w32term.c to xterm.c as expected but after going to nsterm.m
> the modeline buffer id is stuck at nsterm.m.

Probably due to Stefan's changes.  "M-x redraw-display RET" should put
you out of your misery.  (It's entirely possible that just "M-x" will
do.)